=== packaging/ubuntu/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1


%:
	dh $@

override_dh_auto_clean:
	(cd libdivecomputer ; make clean || true)
	make clean || true
	rm -rf libgit2/build
	rm -rf marble-build
	rm -f ssrf-version.h
	rm -f subsurface
	rm -f Makefile

override_dh_auto_configure:
	(cd libdivecomputer ; autoreconf --install ; ./configure --disable-shared ; make -j8 )
	(mkdir libgit2/build ; cd libgit2/build ; \
		cmake -DBUILD_SHARED_LIBS=OFF -DBUILD_CLAR=OFF -DBUILD_EXAMPLES=OFF .. ; \
		sed -i 's/.so$/.a/' CMakeCache.txt ; make -j8 )
	(mkdir marble-build ; cd marble-build ; \
		cmake -DQTONLY=ON -DQT5BUILD=ON \
			-DBUILD_MARBLE_APPS=OFF -DBUILD_MARBLE_EXAMPLES=OFF \
			-DBUILD_MARBLE_TESTS=OFF -DBUILD_MARBLE_TOOLS=OFF \
			-DBUILD_TESTING=OFF -DWITH_DESIGNER_PLUGIN=OFF \
			-DBUILD_WITH_DBUS=OFF ../marble-source ; \
		make -j8 ; \
		mkdir include ; cd include ; for i in `find ../../marble-source -name \*.h` ; do ln -s $$i . ; done ; \
		ln -s . marble )
	qmake LIBDCDEVEL=./libdivecomputer LIBGIT2DEVEL=./libgit2 LIBGIT2STATIC=1 LIBMARBLEDEVEL=./marble-build SPECIAL_MARBLE_PREFIX=1 subsurface.pro

override_dh_installchangelogs:
	dh_installchangelogs
	dh_installchangelogs ReleaseNotes/ReleaseNotes.txt
	txt2html Documentation/user-manual.txt > Documentation/user-manual.html
	mkdir -p debian/subsurface/usr/share/doc/subsurface
	cp Documentation/user-manual.txt debian/subsurface/usr/share/doc/subsurface/
	cp Documentation/user-manual.html debian/subsurface/usr/share/doc/subsurface/html
